import g4p_controls.*;
import java.awt.Color;

String path = sketchPath("");
String[] filenames;
String fileList;

int tlength = 5;
int Otlength = 40;
int vrange = 1024;
int vzero = 0;
int tzero = 0;

float xPos;         // horizontal position of the graph
float xPosOld;
float height_old = 0;
float height_new = 0;

int xwidth = 1000;
int yheight = 500;
int wframe = 50;

Table dtable;
String FileName;

int[] xtime = new int[40000];
float[] yvalue = new float[40000];
int dLength = 40000;
boolean NewData = false;
float inByte;
float inByteOld;
int xval;
int xvalOld;
int mPos;
int mPosX;
int mPosVal;

// int readTime;
// int savedTime = millis();


String selectedText;


public void setup(){
  size(1100, 600, JAVA2D);
  createGUI();
  customGUI();
  // Place your setup code here
  background(255);
  FPath.setText(path); // xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx Select file to read xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
  File file = new File(path);
  
  fileList="";
  String names[] = file.list();
  if (!(names==null)) {
    for (int i=0; i<names.length; i++) {
    if (names[i].toLowerCase().endsWith(".csv")) {
      fileList=fileList+names[i]+"\n";
    }
   }
  }
  // println(fileList);
  
  
  dtable = new Table();
  
  //dtable.addColumn("time");
  //dtable.addColumn("value");
  Directory.setText(fileList); 
  createaxes();
  
}

public void draw(){
  reDrawFigure();
  if (NewData) {
    mPos=mouseX;
    if ((mPos>wframe) && (mPos<wframe+xwidth) && mousePressed) {
      stroke(0);   
      line(mPos,yheight+wframe,mPos,wframe);
        //int mPos;
        //int mPosX;
        //int mPosVal;
      xPos = map(mPos, wframe, xwidth+wframe, 0, tlength*1000);
      xPos=xPos+tzero;
      mPosX=int(xPos);
      int i = 0;
          
      while ((xtime[i] < mPosX) && (i<dLength-1)) {
        i++;
      }
      RecTime.setText(str(xtime[i]));
      RecAmpl.setText(str(yvalue[i]));
    
  }
  }
  SelectFile();
  
}

public void createaxes(){ // Create and draw axes _____________________________________________________________________________-
  
  // Create axes
  
  //background(255);
  
  fill(255);
  stroke(255);
  rect(0,0,xwidth+2*wframe,wframe);
  rect(0,0,wframe,yheight+2*wframe);
  rect(0,yheight+wframe, xwidth+2*wframe,wframe);
  stroke(0);
  strokeWeight(2);
  //background(255);
  line(wframe-2, wframe, wframe-2, wframe+yheight);
  line(wframe, yheight+wframe+2, wframe+xwidth,  yheight+wframe+2);
  
  int dx = xwidth/10;
  for (int i=0; i<11; i++) {
    float dxx = dx*i;
    float x = wframe + dxx;
    stroke(0, 0, 0);
    line(x, yheight+wframe+2, x, yheight+wframe+8);
    fill(0);
    textAlign(CENTER, CENTER);
    float num = tlength;
    num= num/10;
    num=i*num;
    String snum = nf(num, 0, 1);
    text(snum, x, yheight+wframe+16);
  }
  int dy = yheight/4;
  for (int i=0; i<5; i++) {
    float dyy = dy*i;
    float y = yheight+wframe - dyy;
    line(wframe-2, y, wframe-8, y);
    
    textAlign(RIGHT, CENTER);
    float num = vrange;
    num= vrange/4;
    num=i*num;
    String snum = nf(num, 0, 0);
    text(snum, 40, y-2);
  }
   // End create axes
}

public void DataDraw(){ 
    if (NewData)
    {
      background(255);
      createaxes();
      
      stroke(0);
      strokeWeight(2);
      inByteOld = yvalue[0]-vzero;
      if (inByteOld > vrange) {  
        inByteOld = vrange;
      }
      if (inByteOld < 0) {  
        inByteOld = 0;
      }
      inByteOld = map(inByteOld, 0, vrange, 0, yheight);
      height_old = wframe+yheight - inByteOld;
      
      xvalOld=xtime[0]-tzero;
      if (xvalOld > tlength*1000) {  
        xvalOld = tlength*1000;
      }
      if (xvalOld < 0) {  
        xvalOld = 0;
      }
      
      xPosOld = map(xvalOld, 0, tlength*1000, wframe, xwidth+wframe); 
      for (int i = 1; i<dLength; i++) {
        inByte = yvalue[i]-vzero;
        if (inByte > vrange) {  
          inByte = vrange;   //...set the color to black
        }
        if (inByte < 0) {  
          inByte = 0;   //...set the color to black
        }
        inByte = map(inByte, 0, vrange, 0, yheight);
        
        xval=xtime[i]-tzero;
        if (xval > tlength*1000) {  
          xval = tlength*1000;
        }
        if (xval < 0) {  
          xval = 0;
        }
        
        xPos = map(xval, 0, tlength*1000, wframe, xwidth+wframe);  
        height_new = wframe+yheight - inByte; 
        line(xPosOld, height_old, xPos, height_new);
        height_old = height_new;
        xPosOld=xPos;
       //println(xPos,inByte);
      }
      stroke(255);
     //NewData = false;
    }  
}

public void reDrawFigure(){
   background(255); 
   createaxes();
   DataDraw();
  
}

// Use this method to add additional statements
// to customise the GUI controls
public void customGUI(){

}


public void SelectFile(){
  // If we detect a click and the textarea has focus then 
  // the click was over the textarea
  if(Directory.hasFocus()){
    // Get the text insertion point [line no, char no]
    int[] p = Directory.getCaretPos(); 
    // Clear any existing styles
    Directory.clearStyles();
    // Highlight the line (white text on black backgorund)
    Directory.addStyle(G4P.BACKGROUND, Color.BLACK, p[0]);
    Directory.addStyle(G4P.FOREGROUND, Color.WHITE, p[0]);
    // Get the text on the highlighted line
    selectedText = Directory.getText(p[0]);
    
    label1.setText(selectedText);
    
    dtable = loadTable(path+selectedText, "header");
    dLength=dtable.getRowCount();
    
    for (int i = 0; i<dLength; i++) {
      // Access each row of the table one at a time, in a loop.
      //TableRow row = dtable.getRow(i);
      
      xtime[i] = dtable.getInt(i,0);
      yvalue[i] = dtable.getFloat(i,1);
      //println(xtime[i], yvalue[i]);
    }
    
    if (xtime[(dLength-5)]>3000) {
      Otlength=5;
      xMaxSlider.setValue(5);
      //yAmpl.setSelected(0);
      //println(Otlength);
    }
    if (xtime[(dLength-5)]>5500) {
      Otlength=10;
      xMaxSlider.setValue(10);
      //yAmpl.setSelected(1);
      //println(Otlength);
    }
    if (xtime[(dLength-5)]>10500) {
      Otlength=20;
      xMaxSlider.setValue(20);
      //println(Otlength);
    }
    if (xtime[(dLength-20)]>20500) {
      Otlength=40;
      xMaxSlider.setValue(40);
      //println(Otlength);
    }
    tlength=Otlength;
    
    NewData = true;
    Directory.setFocus(false);
    DirectoryPanel.setCollapsed(true);
    //background(255);
   println("HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH");
  // Do something with the data of each row

    
  }
}
